package iims;

/**
*	IIMS.java
*	@author: Ben Farkas
*	@version: 1.0
*
*	This class acts as the user interface when signing on to the IIMS system.
*
*	Date Created: 13, November 2002
**/

import dmc.GUI;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.table.*;
import javax.swing.border.*;
import javax.swing.text.JTextComponent;

import java.io.IOException;

public class IIMS {

static final String SERVER = "dishwasher.cs.rpi.edu";
static final int PORT = 2034;

static JTextPane msignOnField = new JTextPane();
static JTextField msignOnScreenName = new JTextField();

static JTextPane mpasswordField = new JTextPane();
static JPasswordField mpassword = new JPasswordField();

static JPanel mbottomPanel = new JPanel();
static JPanel mtopPanel = new JPanel();

static JFrame frame = new JFrame("Sign On");

static GUI myGUI = null;

JLabel mlogo;

public static void main(String[] args)
{
		IIMS s = new IIMS();
}


/**
*	IIMS The constructor that will set up the GUI and display it on the screen
*	@author: Ben Farkas
*
*	Date Created: 13, November 2002
**/
public IIMS()
{

	frame.setSize(new Dimension(200,200));

	mlogo = new JLabel(new ImageIcon("iims/iims.png"));
	//mlogo.setPreferredSize(new Dimension(177, 122));	//iims.gif
	//mlogo.setPreferredSize(new Dimension(356, 197));	//IIMS.png
	mlogo.setPreferredSize(new Dimension(201, 111));	//iims.png

	mtopPanel.add(mlogo);
	frame.getContentPane().add(mtopPanel, BorderLayout.CENTER);  //add the scrollPane to the frame

	SetUpGUI();

	frame.getContentPane().add( mbottomPanel,BorderLayout.SOUTH);
	frame.pack();
	frame.setVisible(true);
	frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
}

/**
*	SetUpGUI produce the GUI and all associated listeners
*	@author: Ben Farkas
*
*	Date Created: 13, November 2002
**/
private void SetUpGUI()
{

	JPanel screenNamePanel=new JPanel();
	JPanel passwordPanel=new JPanel();
	JPanel buttonPanel=new JPanel();
	ImageIcon signOnIcon = new ImageIcon("iims/smile2.gif");
	JButton signOnButton = new JButton("Sign On", signOnIcon);


	mbottomPanel.setLayout( new GridLayout(3,1) );

	msignOnField.setText("Screen Name:");
	msignOnField.setPreferredSize(new Dimension(100,20));
	msignOnField.setEditable(false);
	msignOnField.setOpaque(false);

	msignOnScreenName.setPreferredSize(new Dimension(100,20));
	msignOnScreenName.setBorder(new EtchedBorder(EtchedBorder.LOWERED));
	msignOnScreenName.setEditable(true);


	mpasswordField.setText("Password: ");
	mpasswordField.setPreferredSize(new Dimension(100,20));
	mpasswordField.setEditable(false);
	mpasswordField.setOpaque(false);

	mpassword.setPreferredSize(new Dimension(100,20));
	mpassword.setBorder(new EtchedBorder(EtchedBorder.LOWERED));
	mpassword.setEditable(true);

	signOnButton.setToolTipText("Sign On To IIMS");

	buttonPanel.add(signOnButton);

	signOnButton.addActionListener( new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
			SignOn();
		}
	});

	screenNamePanel.add(msignOnField);
	screenNamePanel.add(msignOnScreenName);

	passwordPanel.add(mpasswordField);
	passwordPanel.add(mpassword);


	mbottomPanel.add(screenNamePanel);
	mbottomPanel.add(passwordPanel);
	mbottomPanel.add(buttonPanel);


}

/**
*	SignOn  Takes the data in the screen name and password fields and does some error checking then passes the data along to the server
*	@author: Ben Farkas
*
*	Date Created: 13, November 2002
**/
private void SignOn()
{
	String screenName;
	char [] passwd;

	screenName = msignOnScreenName.getText();
	passwd = mpassword.getPassword();

	if ( screenName.length() < 1  ||  screenName.length() > 255 )
	{
		String display = new String("Error: userid must be less that 255 characters");
		JOptionPane.showMessageDialog(frame, display, "OOPS!!", JOptionPane.WARNING_MESSAGE);

	}

	else if ( new String(passwd).length() > 255 )
	{
		String display = new String("Error: password must be less than 255  characters");
		JOptionPane.showMessageDialog(frame, display, "OOPS!!", JOptionPane.WARNING_MESSAGE);

	}




	if(myGUI==null) myGUI  = new GUI();
	frame.setVisible(false);
	myGUI.getTabbedChat().setConnectionType(wtalk.Protocol.PMS);
	myGUI.getTabbedChat().setPassword(new String(passwd));
	try{
	myGUI.getTabbedChat().connect(SERVER, PORT, screenName);
	}catch(IOException e) { 
		JOptionPane.showMessageDialog(frame, "We could not connect to the named host.", "Could not connect", JOptionPane.WARNING_MESSAGE);
		frame.setVisible(true);
	}


// UNCOMMENT WHEN THESE ARE IMPLEMENTED IN CLIENT CLASS
/*
	SetName(screenName);
	SetPassword(passwd);

	if ( TestConnectivity() )
	{
		//ERROR


	}

	if( SignOn() )
	{
		//ERROR



	}
*/


}


}
